package com.psb.ss;

import com.sun.org.apache.bcel.internal.classfile.ClassParser;
import com.sun.org.apache.bcel.internal.classfile.Constant;
import com.sun.org.apache.bcel.internal.classfile.ConstantMethodref;
import com.sun.org.apache.bcel.internal.generic.ClassGen;
import com.sun.org.apache.bcel.internal.generic.ConstantPoolGen;

import java.io.ByteArrayInputStream;
import java.io.IOException;

public class LoaderClient extends ClassLoader {
    public LoaderClient() {
        System.out.println("Done.\nJagex is loading the client...");
    }

    protected final Class<?> defineClassSub(String name, byte[] b, int off, int len) {
        try {
            ClassGen cg = new ClassGen(new ClassParser(new ByteArrayInputStream(b), name).parse());

            ConstantPoolGen cpg = cg.getConstantPool();
            for (Constant con : cpg.getConstantPool().getConstantPool()) {
                if (con != null) {
                    if (con instanceof ConstantMethodref) {
                        ConstantMethodref cm = (ConstantMethodref) con;
                        if (cm.getClass(cpg.getConstantPool()).equals("java.lang.Math")) {
                            cm.setClassIndex(cpg.addClass("com.psb.ss.Hackit"));
                        }
                    }
                }
            }

            cg.setConstantPool(cpg);
            byte buffer[] = cg.getJavaClass().getBytes();
            return super.defineClass(name, buffer, 0, buffer.length);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }
}